//Fragment Shader
#version 440

// Uniforms:
layout(location = 0) uniform mat4 u_ModelMatrix;
layout(location = 100) uniform float u_opacity;
layout(location = 101) uniform vec4 u_modulateColor = vec4(1.0);

// SceneUBO:
//THIS NEEDS TO MATCH SceneUBO.h!
const int LIGHT_COUNT = 50;
const int SHADOWMAP_COUNT = 3;
struct Light {
    vec4 position;
	vec4 direction;
    vec4 color;
	int type;

    float constant;		//no longer needed
    float linear;		//no longer needed
    float quadratic;	//no longer needed
};
layout(std140, binding = 0) uniform Scene {
	mat4 u_ViewMatrix;
	mat4 u_ProjectMatrix;

	mat4 lightViewMatrices[4];
	mat4 lightOrthoProjMatrices[4];
	vec4 cascadeFarZ;				//we use a vec4 here casue glsl wants to pad each element of a float array up to a vec4.
	vec4 u_sunDirection;
	vec4 u_sunColor;

	vec4 u_Iambient;		//ambient illumination color
	int u_LightCount;

	Light u_Lights[LIGHT_COUNT];
};

//Varying:
layout(location=0) out vec4 fragColor;
layout(location=1) in vec2 v_UV;
layout(location=2) in vec3 v_Normal;
layout(location=3) in mat3 TBN;
layout(location=6) in vec4[SHADOWMAP_COUNT] v_modelLightViewVertexPos;
layout(location=9) in vec3 v_WorldPos;

//TEXTURES:
layout(binding=0) uniform sampler2D tex;

//just don't use this
layout(binding=13) uniform sampler2DShadow shadowmap_0;
layout(binding=14) uniform sampler2DShadow shadowmap_1;
layout(binding=15) uniform sampler2DShadow shadowmap_2;



void main() {
	fragColor = vec4(texture(tex, v_UV));
	fragColor *= u_modulateColor;
	fragColor.a = fragColor.a * u_opacity;
}