//Fragment Shader
#version 440

// Uniforms:
layout(location = 0) uniform mat4 u_ModelMatrix;
layout(location = 1) uniform int u_Cascade;		//This is only for the shadowmap


// SceneUBO:
//THIS NEEDS TO MATCH SceneUBO.h!
const int LIGHT_COUNT = 50;
const int SHADOWMAP_COUNT = 3;
struct Light {
    vec4 position;
	vec4 direction;
    vec4 color;
	int type;

    float constant;
    float linear;
    float quadratic;
};
layout(std140, binding = 0) uniform Scene {
	mat4 u_ViewMatrix;
	mat4 u_ProjectMatrix;

	mat4 lightViewMatrices[4];
	mat4 lightOrthoProjMatrices[4];
	vec4 cascadeFarZ;				//we use a vec4 here casue glsl wants to pad each element of a float array up to a vec4.
	vec4 u_sunDirection;
	vec4 u_sunColor;

	vec4 u_Iambient;		//ambient illumination color
	int u_LightCount;

	Light u_Lights[LIGHT_COUNT];
};

//Varying:
layout(location=0) out vec4 fragColor;
layout(location=2) in vec3 v_Normal;



void main() {
	//fragColor = vec4(1.0, 0.0f, 1.0f, 1.0);	//simple debug color
	//fragColor = vec4(abs(v_Normal), 1.0f);
	//fragColor = vec4(vec3(gl_FragCoord.z),1.00f);
}