//Fragment Shader
#version 440

// Uniforms:
layout(location = 100) uniform vec3 u_ModelColor;	// e.g. for solid shader

//Varying:
layout(location=0) out vec4 fragColor;
layout(location=1) in vec2 v_UV;
layout(location=2) in vec3 v_Normal;

//TEXTURES:
layout(binding=0) uniform sampler2D albedoMap;

void main() {
    vec3 albedo;
	
	if (u_ModelColor.rgb == vec3(0.0, 0.0, 0.0)) {
		albedo = texture(albedoMap, v_UV).rgb;
	} else {
		albedo = u_ModelColor.rgb;
	}

	fragColor = vec4(albedo, 1.0);
}