#version 440

// Attributes (per vertex information)
layout (location = 0) in vec3 a_vertex; // <vec2 pos, vec2 tex>
layout(location = 4) in vec2 a_UV;

//uniforms

// SceneUBO:
//THIS NEEDS TO MATCH SceneUBO.h!
const int LIGHT_COUNT = 50;
const int SHADOWMAP_COUNT = 3;
struct Light {
    vec4 position;
	vec4 direction;
    vec4 color;
	int type;

    float constant;
    float linear;
    float quadratic;
};
layout(std140, binding = 0) uniform Scene {
	mat4 u_ViewMatrix;
	mat4 u_ProjectMatrix;

	mat4 lightViewMatrices[4];
	mat4 lightOrthoProjMatrices[4];
	vec4 cascadeFarZ;				//we use a vec4 here casue glsl wants to pad each element of a float array up to a vec4.
	vec4 u_sunDirection;
	vec4 u_sunColor;

	vec4 u_Iambient;		//ambient illumination color
	int u_LightCount;

	Light u_Lights[LIGHT_COUNT];
};


//Varying
layout(location=1) out vec2 v_uv;


void main()
{
    mat4 mvp_Matrix = u_ProjectMatrix;// * u_ModelMatrix;


    gl_Position = mvp_Matrix * vec4(a_vertex, 1.0);
    v_uv = a_UV;
}